<template>
	<div class="border-grey-20 pb-4 mb-4" :class="[this.rowIndex === 0 ? 'border-t-0 md:border-t' : 'border-t']">
		<MkPageSpinner v-if="SHOW_PAGE_SPINNER" />
		<div class="flex" :class="[this.rowIndex === 0 ? 'md:mt-6 mt-0' : 'md:mt-8 mt-8']">
			<div class="w-4/5 md:w-1/2 flex">
				<div role="img" :aria-label="itemObj['name'][apiLocale]" class="flex items-start justify-center mr-4">
					<MKProductImage
						:image-style="'box-border w-75 h-75'"
						:product-detail="itemObj"
						:is-clyde="itemObj.isWarranty"
					/>
				</div>
				<div>
					<p class="font-secondary-font-regular lg:text-xl leading-6">
						{{ itemObj.name[apiLocale] }}
					</p>
					<MKFilterSubscription v-if="FEATURE_SUBSCRIPTION" :item="itemObj" :show-tooltip="true" />
					<div
						class="flex md:hidden flex-wrap items-center justify-start space-x-3 text-sm text-gray-500 font-primary-font-bold"
					>
						<MkQuantityDropdown
							id="full_cart_mobile_qty"
							:ref="`${rowIndex}qty`"
							:aria-label="itemObj['name'][apiLocale]"
							:value="itemObj.quantity"
							@change="updateValue"
						/>
					</div>
				</div>
			</div>
			<div class="w-1/5 md:w-1/2 flex flex-col">
				<div
					class="flex justify-end md:justify-between w-full"
					:class="[itemObj.priceDisplay.strikePrice > 0 ? '' : 'items-center']"
				>
					<div class="hidden md:block">
						<span class="font-primary-font-light"
							>{{ currencyDisplay }}{{ itemObj['price']['value']['centAmount'] | centsToDollars }}</span
						>
					</div>
					<div class="hidden md:block">
						<MkQuantityDropdown
							:id="itemObj['name'][apiLocale]"
							:ref="rowIndex"
							:aria-label="itemObj['name'][apiLocale]"
							:value="itemObj.quantity"
							@change="updateValue"
						/>
					</div>
					<div class="flex flex-col items-end">
						<MkActualPrice
							v-show="itemObj.priceDisplay.strikePrice > 0"
							aria-hidden="true"
							:actual-price="itemObj.priceDisplay.strikePrice"
						/>

						<span v-if="itemObj.priceDisplay.strikePrice > 0" class="sr-only">
							Original price was {{ currencyDisplay
							}}{{ itemObj.priceDisplay.strikePrice | centsToDollars | formatPrice }}, current price is
							{{ currencyDisplay }}{{ itemObj.priceDisplay.price | centsToDollars | formatPrice }}
						</span>
						<span v-if="itemObj.priceDisplay.strikePrice > 0" class="md:font-bold" aria-hidden="true">
							{{ currencyDisplay }}{{ itemObj.priceDisplay.price | centsToDollars | formatPrice }}</span
						>
						<span v-else class="md:font-bold"
							>{{ currencyDisplay
							}}{{ (itemObj.quantity * itemObj.price.value['centAmount']) | centsToDollars | formatPrice }}</span
						>
					</div>
				</div>
				<div
					:class="
						itemObj && itemObj.priceDisplay && itemObj.priceDisplay.strikePrice > 0
							? 'flex lg:h-6 md:h-3 h-2'
							: 'flex lg:h-7 md:h-6 h-8'
					"
				></div>
				<div class="flex justify-end">
					<div class="text-sm text-gray-500 font-primary-font-bold">
						<button
							class="focus:ring-trasparaent"
							:aria-label="`${itemObj['name'][apiLocale]} Close`"
							@click="removeFullLineItem"
						>
							<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 12 11" class="w-3 h-3 fill-current">
								<g fill="none" fill-rule="evenodd">
									<g fill="#D7D5D4">
										<g>
											<g>
												<g>
													<path
														d="M10.125 3.25c.552 0 1 .448 1 1l-.001 4.624 4.626.001c.552 0 1 .448 1 1v.25c0 .552-.448 1-1 1l-4.626-.001.001 4.626c0 .552-.448 1-1 1h-.25c-.552 0-1-.448-1-1l-.001-4.626-4.624.001c-.552 0-1-.448-1-1v-.25c0-.552.448-1 1-1l4.624-.001.001-4.624c0-.552.448-1 1-1h.25z"
														transform="translate(-345 -363) translate(15 268) translate(92 89.554) translate(234 .661) rotate(45 10 10)"
													></path>
												</g>
											</g>
										</g>
									</g>
								</g>
							</svg>
						</button>
						<p v-if="removeSuccess" role="alert" aria-live="polite" class="sr-only" :aria-label="successText"></p>
					</div>
				</div>
			</div>
		</div>
		<div v-if="FEATURE_CLYDE" class="mt-3 md:mt-6">
			<MkClydeButton :item="itemObj" />
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkQuantityDropdown from '~/components/D2C/molecules/MkQuantityDropdown/MkQuantityDropdown.vue';
import MkClydeButton from '~/components/D2C/atoms/MkClydeButton.vue';
import MKProductImage from '~/components/D2C/organisms/MkProductImage/MkProductImage.vue';
import MKFilterSubscription from '~/components/D2C/molecules/MkFilterSubscription/MkFilterSubscription.vue';
import MkPageSpinner from '~/components/D2C/atoms/MkPageSpinner/MkPageSpinner.vue';
import MkActualPrice from '~/components/D2C/atoms/MkActualPrice.vue';
export default {
	name: 'MkLandingCart',
	components: {
		MkClydeButton,
		MkQuantityDropdown,
		MKProductImage,
		MKFilterSubscription,
		MkPageSpinner,
		MkActualPrice,
	},
	props: {
		item: {
			type: [Object, String, Array],
			default() {
				return {};
			},
		},
		rowIndex: {
			type: Number,
			default: 0,
		},
	},
	data() {
		return {
			product_name: '',
			productImg: '',
			hasQuote: false,
			queryData: '', // Added for DEMO Route
			itemObj: this.item,
			successText: 'Product removed successfully',
			removeSuccess: false,
		};
	},
	watch: {
		item() {
			this.itemObj = this.item;
		},
	},
	computed: {
		...mapState(['currencyDisplay', 'apiLocale']),
		...mapState('CART_STORE', ['CART_ID', 'DISCOUNT_PRICE', 'SUB_TOTAL_PRICE', 'LINE_ITEMS']),
		...mapState('USER_STORE', ['AUTHENTICATED', 'CUSTOMERID', 'CUSTOMER_DETAILS_D2C_TEALIUM']),
		...mapState('CHECKOUT_STORE', ['SHOW_PAGE_SPINNER', 'FEATURE_CLYDE', 'FEATURE_SUBSCRIPTION']),
	},
	mounted() {
		this.queryData = this.$route.query.show; // Added for DEMO Route
	},
	beforeDestroy() {
		this.$emit('set-focus', this.rowIndex);
	},
	methods: {
		async removeFullLineItem() {
			try {
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
				const newProductPayload = {
					action: 'REMOVE_LINE_ITEM',
					lineItemId: this.itemObj.id,
					productId: this.itemObj.productId || null,
					quantity: this.itemObj.quantity,
				};
				this.removeSuccess = true;
				await this.$store.dispatch('CART_STORE/ADD_REMOVE_FROM_CART', newProductPayload);
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
				this.cartOperation('remove');
			} catch (error) {
				// console.error(error)
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			}
		},
		async addQuantity() {
			try {
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
				const newProductPayload = {
					action: 'CHANGE_LINE_ITEM_QTY',
					lineItemId: this.itemObj.id,
					productId: this.itemObj.productId || null,
					quantity: this.itemObj.quantity,
					skuId: '',
				};
				await this.$store.dispatch('CART_STORE/ADD_REMOVE_FROM_CART', newProductPayload);
				this.cartOperation('increase');
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			} catch (error) {
				// move to global error handler
				// console.log(error)
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			}
		},
		async removeQuantity() {
			try {
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
				const newProductPayload = {
					action: 'CHANGE_LINE_ITEM_QTY',
					lineItemId: this.itemObj.id,
					productId: this.itemObj.productId || null,
					quantity: this.itemObj.quantity,
					skuId: '',
				};
				await this.$store.dispatch('CART_STORE/ADD_REMOVE_FROM_CART', newProductPayload);
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
				this.cartOperation('decrease');
			} catch (error) {
				// move to global error handler
				// console.log(error)
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			}
		},
		updateValue(newValue) {
			if (newValue) {
				if (newValue > this.itemObj.quantity) {
					this.itemObj.quantity = newValue;
					// this.itemObj.quantity = newValue
					this.addQuantity();
				} else if (newValue < this.itemObj.quantity) {
					this.itemObj.quantity = newValue;
					// this.itemObj.quantity = newValue
					this.removeQuantity();
				}
			} else if (newValue === 0) {
				this.removeFullLineItem();
			}
		},
		async cartOperation(key) {
			const customerDetails = this.$store.state.USER_STORE.CUSTOMER_DETAILS_D2C_TEALIUM;
			const tealiumPayload = {
				page_type: 'cart',
				cart_id: this.CART_ID,
				cart_product_id: [...new Set(this.LINE_ITEMS.map((x) => x.productId))],
				cart_product_quantity: [...new Set(this.LINE_ITEMS.map((x) => x.quantity.toFixed(0) || '1'))],
				cart_product_sku: [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))],
				cart_total_items: this.LINE_ITEMS.length.toFixed(0),
				cart_total_value: this.$root.$utility.centsToDollarsConvert(this.SUB_TOTAL_PRICE),
				cart_discount: [this.$root.$utility.centsToDollarsConvert(this.DISCOUNT_PRICE)],
				product_brand: [...new Set(this.LINE_ITEMS.map((x) => x.product_brand || 'Molekule'))],
				product_category: [...new Set(this.LINE_ITEMS.map((x) => x.productType?.obj?.name || 'Filters'))],
				product_discount_amount: [...new Set(this.LINE_ITEMS.map((x) => x.product_discount_amount || '0'))],
				product_name: [...new Set(this.LINE_ITEMS.map((x) => x.name[this.apiLocale]))],
				product_promo_code: '',
				product_quantity: [...new Set(this.LINE_ITEMS.map((x) => x.quantity.toFixed(0) || '1'))],
				product_sku: [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))],
				product_id: [...new Set(this.LINE_ITEMS.map((x) => x.productId))],
				product_in_stock: [...new Set(this.LINE_ITEMS.map((x) => x.productStockCount || ''))],
				product_plan_details: [...new Set(this.LINE_ITEMS.map((x) => x.cartItemSubscriptionData?.productPlan || ''))],
				product_renewal_date: [...new Set(this.LINE_ITEMS.map((x) => x.cartItemSubscriptionData?.nextRefill || ''))],
				product_review_stars: [...new Set(this.LINE_ITEMS.map((x) => x.averageRating || '1'))],
				event_category: 'Cart',
				...customerDetails,
			};
			const productImgUrl = [];
			for (let i = 0; i < this.LINE_ITEMS.length; i++) {
				productImgUrl.push(await this.$root.$getImage(this.LINE_ITEMS[i]?.variant?.sku));
			}
			tealiumPayload.product_image_url = productImgUrl;
			const listPriceArray = [];
			const productListPrice = [...new Set(this.LINE_ITEMS.map((x) => x.price))];
			productListPrice.forEach((el) => {
				if (el.value) {
					listPriceArray.push(this.$root.$utility.centsToDollarsConvert(el.value.centAmount, el.value.fractionDigits));
				}
			});
			tealiumPayload.cart_product_price = listPriceArray;
			tealiumPayload.cart_product_list_price = listPriceArray;
			tealiumPayload.productListPrice = listPriceArray;
			tealiumPayload.product_price = listPriceArray;
			if (key === 'increase') {
				tealiumPayload.event_action = 'Changed Quantity';
				tealiumPayload.event_label = 'Increased';
				tealiumPayload.event_value = [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))];
				this.$root.$telium.setTealiumPayload('quantity_increase', tealiumPayload);
			} else if (key === 'decrease') {
				tealiumPayload.event_action = 'Changed Quantity';
				tealiumPayload.event_label = 'Decreased';
				tealiumPayload.event_value = [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))];
				this.$root.$telium.setTealiumPayload('quantity_decrease', tealiumPayload);
			} else if (key === 'remove') {
				tealiumPayload.event_action = 'Removed from Cart';
				tealiumPayload.event_label = 'Removed :' + [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))];
				this.$root.$telium.setTealiumPayload('cart_remove', tealiumPayload);
			}
		},
	},
};
</script>

<style>
.icon-notification:hover::before {
	@apply text-black;
}
</style>
